"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpUtil = exports.RESPONCE_TYPE = exports.DELETE = exports.PUT = exports.POST = exports.GET = void 0;
exports.GET = "GET";
exports.POST = "POST";
exports.PUT = "PUT";
exports.DELETE = "DELETE";
exports.RESPONCE_TYPE = {
    TEXT: "text",
    JSON: "json",
    XML: "xml"
};
class HttpUtil {
    static fetchData(path, method, responceType, body = null) {
        let url = "";
        let option = {
            method: method,
            headers: {
                "content-type": "application/json; charset=utf-8"
            }
        };
        url = path;
        if (body)
            option["body"] = JSON.stringify(body);
        return new Promise((resolve, reject) => {
            fetch(url, option)
                .then((res) => {
                if (responceType == exports.RESPONCE_TYPE.TEXT)
                    return res.text();
                else
                    return res.json();
            })
                .then((result) => {
                resolve(result);
            })
                .catch((err) => {
                reject(err);
            });
        });
    }
    static post(path, body, responceType = exports.RESPONCE_TYPE.JSON) {
        return this.fetchData(path, exports.POST, responceType, body);
    }
    static put(path, body, responceType = exports.RESPONCE_TYPE.JSON) {
        return this.fetchData(path, exports.PUT, responceType, body);
    }
    static get(path, responceType = exports.RESPONCE_TYPE.JSON) {
        return this.fetchData(path, exports.GET, responceType);
    }
    static delete(path, body, responceType = exports.RESPONCE_TYPE.JSON) {
        return this.fetchData(path, exports.DELETE, responceType, body);
    }
    static fetchDataFullUrl(path, method, body = null) {
        let url = "";
        let option = {
            method: method,
            mode: "no-cors",
            headers: {
                "content-type": "application/json; charset=utf-8",
                "Access-Control-Allow-Origin": "*",
                "Access-Control-Request-Method": "GET",
                "Access-Control-Request-Headers": "content-type"
            }
        };
        url = path;
        if (body)
            option["body"] = JSON.stringify(body);
        return new Promise((resolve, reject) => {
            fetch(url, option)
                .then((res) => res.text())
                .then((result) => {
                resolve(result);
            })
                .catch((err) => {
                reject(err);
            });
        });
    }
}
exports.HttpUtil = HttpUtil;
//# sourceMappingURL=HttpUtil.js.map